package cn.ibizlab.humanresource.core.humanresource.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.humanresource.core.humanresource.domain.HRWorkRecord;
import cn.ibizlab.humanresource.core.humanresource.filter.HRWorkRecordSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[HRWorkRecord] 服务对象接口
 */
public interface IHRWorkRecordService extends IService<HRWorkRecord>{

    boolean create(HRWorkRecord et) ;
    void createBatch(List<HRWorkRecord> list) ;
    boolean update(HRWorkRecord et) ;
    void updateBatch(List<HRWorkRecord> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    HRWorkRecord get(String key) ;
    HRWorkRecord getDraft(HRWorkRecord et) ;
    boolean checkKey(HRWorkRecord et) ;
    boolean save(HRWorkRecord et) ;
    void saveBatch(List<HRWorkRecord> list) ;
    Page<HRWorkRecord> searchDefault(HRWorkRecordSearchContext context) ;
    List<HRWorkRecord> selectByHremployeeid(String employeeid) ;
    void removeByHremployeeid(String employeeid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<HRWorkRecord> getHrworkrecordByIds(List<String> ids) ;
    List<HRWorkRecord> getHrworkrecordByEntities(List<HRWorkRecord> entities) ;
}


